section .data
	inputBuffer db '0000000000000000000',0
	outputBuffer db '-00000000000000000000',10

section .text
	global _start

_start:
	; read syscall
	xor rax, rax
	xor rdi, rdi
	mov rsi, inputBuffer
	push 19
	pop rdx
	syscall
	
	; Check if string is negative
	mov rcx, rax
	mov al, [rsi]
	cmp al, '-'
	je strSigned
	push 0
	jmp endStrSigned
strSigned:
	push 1
	dec rcx
	inc rsi
endStrSigned:
	
	; Read the digits and create the number
	xor rax, rax
	xor rbx, rbx
	push '0'
	pop rdi
	push 10
	pop r8
readDigit:
	mov bl, [rsi]
	sub bl, dil
	cmp bl, r8b
	jae endReadDigit
	mul r8
	add rax, rbx
	inc rsi
	loop readDigit
endReadDigit:
	
	; Make the number negative if asked
	pop rbx
	test rbx, rbx
	jz endNegate
	neg rax
endNegate:
	push rax

;==============================================================================

	; Check if number is negative
	pop rax
	test rax, rax
	js numSigned
	mov rsi, outputBuffer+1
	jmp endNumSigned
numSigned:
	mov rsi, outputBuffer
	neg rax
endNumSigned:
	
	; Do the divisions
	push 10
	pop rbx
	xor rcx, rcx
divideLoop:
	xor rdx, rdx
	div rbx
	push rdx
	inc rcx
	test rax, rax
	jnz divideLoop
	
	; Write the digits
	push '0'
	pop rdi
	mov rdx, outputBuffer+1
writeDigit:
	pop rax
	add rax, rdi
	mov [rdx], al
	inc rdx
	loop writeDigit
	mov [rdx], bl		; rbx still contains 10
	inc rdx
	
	; write syscall
	sub rdx, rsi
	push 1
	pop rax
	mov rdi, rax
	syscall
	
	; exit syscall
	mov rax, 0x3c
	xor rdi, rdi
	syscall

